/* (c) 2001 Brad Spengler  */

#include "includes.h"
#include "snorthead.h"


int parseline(char *ibuf)
{
	char *p,*pend;
	int x;
	char buf[1024];
	strncpy(buf,ibuf,sizeof(buf));
	/*  extract intrusion name and category */
	if (!strncmp(buf,"[**]",4)){
		p = buf + 5;
		if((p=grchr(p,']',strlen(p))) != NULL){
			p += 2;
			pend=grchr(p,' ',strlen(p));
			*pend = '\0';
			strncpy(ids[count].cat,p,sizeof(ids[count].cat));
			if(*(pend+1) == '-') { 
				pend++; 
				p=grchr(pend,' ',strlen(pend));
				pend=p;
			}
			pend++;	
			p=grchr(pend,'[',strlen(pend));
			*--p = '\0';
			strncpy(ids[count].name,pend,sizeof(ids[count].name));
		} else return 1;
	} 
	/*  extract priority  */
	else if (strstr(buf,"[Priority:")) {
		if((p = grchr(buf,']',strlen(buf))) != NULL) {
			p += 13;
			pend = grchr(p,']',strlen(p));
			*pend = '\0';
			ids[count].priority = (unsigned short) atoi(p);
		} else return 1;
	}
	/*  extract time, src ip, port dst ip, port  */
	else if (strstr(buf,"->") && (buf[2] == '/') && (buf[5] == '-')) { 
		buf[14] = '\0';
		pend = buf + 15;
		strncpy(ids[count].time,buf,sizeof(ids[count].time));
		if((p=grchr(pend,' ',strlen(pend))) != NULL){
			p++;
			if((pend=grchr(p,':',strlen(p))) != NULL) {
				*pend = '\0';
				strncpy(ids[count].src_ip,p,sizeof(ids[count].src_ip));
				pend++;
				p=grchr(pend,' ',strlen(pend));
				*p = '\0';
				ids[count].src_port = atoi(pend);
				p += 4;
				pend=grchr(p,':',strlen(p));
				*pend = '\0';
				strncpy(ids[count].dst_ip,p,sizeof(ids[count].dst_ip));
				pend++;
				p=grchr(pend,'\n',strlen(pend));
				*p='\0';
				ids[count].dst_port = atoi(pend);
			}  /*  line doesn't contain port info  */ 
			else {
				ids[count].dst_port = 0;
				ids[count].src_port = 0;
				pend = grchr(p,' ',strlen(p));
				*pend = '\0';
				strncpy(ids[count].src_ip,p,sizeof(ids[count].src_ip));
				pend += 4;
				p=grchr(pend,'\n',strlen(pend));
				*p = '\0';
				strncpy(ids[count].dst_ip,pend,sizeof(ids[count].dst_ip));
			}
		/*  check for dupes. if found, increase occurrence  */
		for(x=0;x<count;x++) {
		if(!strcmp(ids[count].name,ids[x].name) &&
		   !strcmp(ids[count].dst_ip,ids[x].dst_ip) &&
		   !strcmp(ids[count].src_ip,ids[x].src_ip) &&
		   !strcmp(ids[count].cat,ids[x].cat) &&
		   ((ids[count].src_port == ids[x].src_port) ||
		   (ids[count].dst_port == ids[x].dst_port))) {
			ids[x].occurrence++;
			return 1;
		}
		}
		count++;
		} else return -1;
	}
	return 0;
}
