/* (c) 2001 Brad Spengler  */

#define IDS_MAX 8000

struct ids_info {
        char name[64];
        char cat[32];
        char src_ip[16];
        char dst_ip[16];
        unsigned int src_port;
        unsigned int dst_port;
	char time[15];
	unsigned short priority;
	unsigned long occurrence;
} ids[IDS_MAX];

extern unsigned int count;

#define ST_NAME   1
#define ST_CAT    2
#define ST_SRCIP  3
#define ST_DSTIP  4
#define ST_SRCPRT 5
#define ST_DSTPRT 6
#define ST_TIME   7
#define ST_OCCUR  8
#define ST_PRIORITY 9

#define LOGFILE "/var/log/snort/alert"
#define LOGBASE "/var/log/snort"

/* refresh time */
#define REFRESH "120"
