/* (c) 2001 Brad Spengler  */

#include "includes.h"
#include "snorthead.h"

extern void sortstruct(int mode,int asc,unsigned int outnum);

char topname[240];
char topsrcip[200];
char topdstip[200];
char topcat[32];

char * namerate(int asc,int tasc,int numout,short big)
{
	int i = 0;
	int max;
	int tmpmax = 0;

	max = (big ? 0 : -numout);

	sortstruct(ST_TIME,tasc,count);
	sortstruct(ST_NAME,asc,numout);
	for(i=0;i<numout;i++) {
		if(!strcmp(ids[i].name,ids[i+1].name) && (i != (numout - 1)))
			(big ? tmpmax++ : tmpmax --);
		else {
			if ( i == (numout - 1))
				(big ? tmpmax++ : tmpmax --);
			if(tmpmax > max) {
				max = (big ? ++tmpmax : --tmpmax);
				snprintf(topname,sizeof(topname),
				"%s\n",
				ids[i].name);
			}
			tmpmax = 0;
		}
	}		

	if(!max || (max == -numout))
		snprintf(topname,sizeof(topname),
                                "%s\n",
                                ids[0].name);	

	return topname;
}

char * catrate(int asc, int tasc,int numout, short big)
{
	int i = 0;
	int max;
	int tmpmax = 0;

	max = (big ? 0 : -numout);

	sortstruct(ST_TIME,tasc,count);
	sortstruct(ST_CAT,asc,numout);
	for(i=0;i<numout;i++) {
		if(!strcmp(ids[i].cat,ids[i+1].cat) && (i != (numout - 1)))
			(big ? tmpmax++ : tmpmax --);
		else {
  			if ( i == (numout - 1))
				(big ? tmpmax++ : tmpmax --);
			if(tmpmax > max) {
				max = (big ? ++tmpmax : --tmpmax);
				strncpy(topcat,ids[i].cat,sizeof(topcat));
			}
			tmpmax = 0;
		}
	}		

	if(!max || (max == -numout))
		strncpy(topcat,ids[0].cat,sizeof(topcat));

	return topcat;
}

char * srciprate(int asc,int tasc, int numout, short big)
{
	int i = 0;
	int max;
	int tmpmax = 0;

	max = (big ? 0 : -numout);

	sortstruct(ST_TIME,tasc,count);
	sortstruct(ST_SRCIP,asc,numout);
	for(i=0;i<numout;i++) {
		if(!strcmp(ids[i].src_ip,ids[i+1].src_ip) && (i != (numout - 1)))
			(big ? tmpmax++ : tmpmax --);
		else {
                        if ( i == (numout - 1))
				(big ? tmpmax++ : tmpmax --);
			if(tmpmax > max) {
				max = (big ? ++tmpmax : --tmpmax);
				snprintf(topsrcip,sizeof(topsrcip),
	            		"<A HREF=\"nslookup.cgi?h=%s\">%s</A>",
				ids[i].src_ip,ids[i].src_ip);
			}
			tmpmax = 0;
		}
	}		

	if(!max || (max == -numout))
                 snprintf(topsrcip,sizeof(topsrcip),
                 "<A HREF=\"nslookup.cgi?h=%s\">%s</A>",
                 ids[0].src_ip,ids[0].src_ip);

	return topsrcip;
}

char * dstiprate(int asc, int tasc, int numout, short big)
{
	int i = 0;
	int max;
	int tmpmax = 0;

	max = (big ? 0 : -numout);

	sortstruct(ST_TIME,tasc,count);
	sortstruct(ST_DSTIP,asc,numout);
	for(i=0;i<numout;i++) {
		if(!strcmp(ids[i].dst_ip,ids[i+1].dst_ip) && (i != (numout - 1)))
			(big ? tmpmax++ : tmpmax --);
		else {
                        if ( i == (numout - 1))
				(big ? tmpmax++ : tmpmax --);
			if(tmpmax > max) {
				max = (big ? ++tmpmax : --tmpmax);
				snprintf(topdstip,sizeof(topdstip),
	            "<A HREF=\"nslookup.cgi?h=%s\">%s</A>",
				ids[i].dst_ip,ids[i].dst_ip);
			}
			tmpmax = 0;
		}
	}		

	if(!max || (max == -numout))
                 snprintf(topdstip,sizeof(topdstip),
                 "<A HREF=\"nslookup.cgi?h=%s\">%s</A>",
                 ids[0].dst_ip,ids[0].dst_ip);

	return topdstip;
}

